fix common.config to allow SCRATCH_DEV and SCRATCH_MNT to be optional
[xfstests-dev.git] / 180
1 #! /bin/sh
2 # FSQA Test No. 180
3 #
4 # Test for NULL files problem
5 # test inode size is on disk after sync
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #
23 #-----------------------------------------------------------------------
24 #
25 # creator
26 owner=lachlan@sgi.com
27
28 seq=`basename $0`
29 echo "QA output created by $seq"
30
31 here=`pwd`
32 tmp=/tmp/$$
33 status=1    # failure is the default!
34 trap "_cleanup; exit \$status" 0 1 2 3 15
35
36 _cleanup()
37 {
38     _cleanup_testdir
39 }
40
41 # get standard environment, filters and checks
42 . ./common.rc
43 . ./common.filter
44
45 # real QA test starts here
46 _supported_fs xfs
47 _supported_os Linux IRIX
48
49 _setup_testdir
50 _require_scratch
51 _scratch_mkfs_xfs >/dev/null 2>&1
52 _scratch_mount
53
54 # Do we have enough space on disk?
55 FREE_BLOCKS=`df -klP $SCRATCH_MNT | grep -v Filesystem | awk '{print $4}'`
56 [ $FREE_BLOCKS -lt 10485760 ] && _notrun "This test requires at least 10GB of \
57                                           $SCRATCH_DEV to run"
58
59 _check_files()
60 {
61         # check file size and contents
62         i=1;
63         while [ $i -lt 1000 ]
64         do
65                 file=$SCRATCH_MNT/$i
66                 # if file is missing then sync failed
67                 if [ -e $file ]
68                 then
69                         # if file size is not 10MB then sync failed
70                         if [ `ls -l $file | tr -s ' ' | cut -d ' ' -f 5` -eq 10485760 ]
71                         then
72                                 # if file has non-zero size but no extents then it's contents will be NULLs, bad.
73                                 if xfs_bmap $file | grep 'no extents' > /dev/null
74                                 then
75                                         echo corrupt file $file - non-zero size but no extents
76                                 else
77                                         rm -f $file
78                                 fi
79                         else
80                                 echo file $file has incorrect size - sync failed
81                         fi
82                 else
83                         echo file $file missing - sync failed
84                 fi
85                 let i=$i+1
86         done
87 }
88
89 # create files and sync them
90 i=1;
91 while [ $i -lt 1000 ]
92 do
93         file=$SCRATCH_MNT/$i
94         xfs_io -f -c "pwrite -b 64k -S 0xff 0 10m" $file > /dev/null
95         if [ $? -ne 0 ]
96         then
97                 echo error creating/writing file $file
98                 exit
99         fi
100         let i=$i+1
101 done
102
103 # sync, then shutdown immediately after, then remount and test
104 sync
105 src/godown $SCRATCH_MNT
106 umount $SCRATCH_MNT
107 _scratch_mount
108 umount $SCRATCH_MNT
109 if [ ! _check_scratch_fs ]
110 then
111         echo error detected in filesystem
112         exit
113 fi
114 _scratch_mount
115 _check_files
116
117 status=0
118 exit